Index: /trunk/src/sh_mem.c
===================================================================
--- /trunk/src/sh_mem.c	(revision 584)
+++ /trunk/src/sh_mem.c	(revision 1)
@@ -20,7 +20,4 @@
 #include "config_xor.h"
 
-#if defined(HAVE_PTHREAD_MUTEX_RECURSIVE)
-#define _XOPEN_SOURCE 500
-#endif
 
 #include <stdio.h>
@@ -35,16 +32,14 @@
 #endif
 
-#define SH_REAL_SET
-
 #include "samhain.h"
 #include "sh_error.h"
 #include "sh_utils.h"
 #include "sh_mem.h"
-#include "sh_pthread.h"
-
-extern int safe_logger (int thesignal, int method, char * details);
+
+extern int safe_logger (int signal, int method, pid_t thepid);
 
 #undef  FIL__
 #define FIL__  _("sh_mem.c")
+static int eblock = 0;
 
 #ifdef MEM_DEBUG
@@ -73,41 +68,51 @@
 unsigned long Mem_Current = 0, Mem_Max = 0;
 
-#ifdef HAVE_PTHREAD
-SH_MUTEX_RECURSIVE(mutex_mem);
-#endif
-
-/* define MEM_LOG to enable this */
-/* #define MEM_LOG 1 */
+#if 0
+#define MEM_DETAILS 
+#endif
+
+#ifdef MEM_DETAILS
+int           max_upto_032 = 0;
+int           max_upto_064 = 0;
+int           max_upto_128 = 0;
+int           max_upto_256 = 0;
+int           max_upto_512 = 0;
+int           max_upto_1024 = 0;
+int           max_upto_4096 = 0;
+int           max_upto_inf = 0;
+
+int           now_upto_032 = 0;
+int           now_upto_064 = 0;
+int           now_upto_128 = 0;
+int           now_upto_256 = 0;
+int           now_upto_512 = 0;
+int           now_upto_1024 = 0;
+int           now_upto_4096 = 0;
+int           now_upto_inf = 0;
+
+int           tot_upto_032 = 0;
+int           tot_upto_064 = 0;
+int           tot_upto_128 = 0;
+int           tot_upto_256 = 0;
+int           tot_upto_512 = 0;
+int           tot_upto_1024 = 0;
+int           tot_upto_4096 = 0;
+int           tot_upto_inf = 0;
+#endif
+
 #ifdef MEM_LOG
 void sh_mem_dump ()
 {
   memlist_t   * this = memlist;
-  FILE * fd;
-  static unsigned int nr = 0;
-  char filename[256];
-
-  snprintf(filename, sizeof(filename), "sh_mem_dump.%04u.%lu", nr, (unsigned long) sh.pid);
-  
-  SH_MUTEX_RECURSIVE_INIT(mutex_mem);
-  SH_MUTEX_RECURSIVE_LOCK(mutex_mem);
-
-  fd = fopen(filename, "w");
-  if (!fd)
-    {
-      perror(filename);
-      _exit(EXIT_FAILURE);
-    }
+
+
+  FILE * fd = fopen(MEM_LOG, "w");
 
   while (this != NULL)
     {
-      fprintf (fd, "## %20s %5d %ld\n",  this->file, this->line, this->size);
-      fprintf (fd, "%10p %8ld\n", (void *)this->address, this->size);
+      fprintf (fd, "%20s %5d %ld\n",  this->file, this->line, this->size);
       this = this->next;
     }
-  sl_fclose(FIL__, __LINE__, fd);
-
-  SH_MUTEX_RECURSIVE_UNLOCK(mutex_mem);
-  ++nr;
-  /* _exit(EXIT_SUCCESS); */
+  fclose(fd);
   return;
 }
@@ -119,14 +124,10 @@
 #endif
 
-memlist_t ** sh_dummy_114_merrlist;
-
 void sh_mem_stat ()
 {
   memlist_t   * this;
-  memlist_t   * merrlist = NULL;
+
 
   SL_ENTER(_("sh_mem_stat"));
-
-  sh_dummy_114_merrlist = (memlist_t **) &merrlist;
 
   if (Alloc_Count == Free_Count) 
@@ -142,6 +143,17 @@
 		   Mem_Max, Mem_Current);
 
-  SH_MUTEX_RECURSIVE_INIT(mutex_mem);
-  SH_MUTEX_RECURSIVE_LOCK(mutex_mem);
+#ifdef MEM_DETAILS
+  fprintf(stderr, "\n");
+  fprintf(stderr, "__SIZE_____TOTAL___MAXIMUM___\n");
+  fprintf(stderr, "    32    %6d    %6d\n", tot_upto_032, max_upto_032);
+  fprintf(stderr, "    64    %6d    %6d\n", tot_upto_064, max_upto_064);
+  fprintf(stderr, "   128    %6d    %6d\n", tot_upto_128, max_upto_128);
+  fprintf(stderr, "   256    %6d    %6d\n", tot_upto_256, max_upto_256);
+  fprintf(stderr, "   512    %6d    %6d\n", tot_upto_512, max_upto_512);
+  fprintf(stderr, "  1024    %6d    %6d\n", tot_upto_1024, max_upto_1024);
+  fprintf(stderr, "  4096    %6d    %6d\n", tot_upto_4096, max_upto_4096);
+  fprintf(stderr, "   inf    %6d    %6d\n", tot_upto_inf, max_upto_inf);
+  fprintf(stderr, "\n");
+#endif
 
   this = memlist;
@@ -149,47 +161,22 @@
   while (this != NULL) 
     {
-      memlist_t   * merr = calloc(1,sizeof(memlist_t));
-
-      memcpy(merr, this, sizeof(memlist_t));
-      merr->next = merrlist;
-      merrlist   = merr;
-
+      sh_error_handle (SH_ERR_WARN, FIL__, __LINE__, 0, MSG_E_NOTFREE,
+		       this->size, this->file, this->line);
       this = this->next;
     }
 
-  SH_MUTEX_RECURSIVE_UNLOCK(mutex_mem);
-
-  while (merrlist != NULL) 
-    {
-      memlist_t   * tmp = merrlist;
-      merrlist = merrlist->next;
-      
-      sh_error_handle (SH_ERR_WARN, FIL__, __LINE__, 0, MSG_E_NOTFREE,
-		       tmp->size, tmp->file, tmp->line);
-      free(tmp);
-    }
-
   SL_RET0(_("sh_mem_stat"));
 }
 
-memlist_t ** sh_dummy_168_merrlist;
-
 void sh_mem_check ()
 {
   memlist_t * this;
-  memlist_t * merrlist = NULL;
-  memlist_t * merr;
   long        nerr = 0;
 
   SL_ENTER(_("sh_mem_check"));
-
-  sh_dummy_168_merrlist = (memlist_t **) &merrlist;
 
   sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_MSTAMP,
 		   Mem_Max, Mem_Current);
 
-  SH_MUTEX_RECURSIVE_INIT(mutex_mem);
-  SH_MUTEX_RECURSIVE_LOCK(mutex_mem);
-
   this = memlist;
 
@@ -198,11 +185,5 @@
       if ( this->address == NULL )
 	{
-	  merr = calloc (1,sizeof(memlist_t));
-
-	  memcpy(merr, this, sizeof(memlist_t));
-	  merr->size = 2;
-
-	  merr->next = merrlist;
-	  merrlist   = merr;
+	  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MNULL);
 	  ++nerr;
 	}
@@ -211,22 +192,12 @@
 	  if ( this->address[this->size]        != CHECKBYTE )
 	    {
-	      merr = calloc(1, sizeof(memlist_t));
-	      
-	      memcpy(merr, this, sizeof(memlist_t));
-	      merr->size = 1;
-	      
-	      merr->next = merrlist;
-	      merrlist   = merr;
+	      sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MOVER,
+			       this->file, this->line, FIL__, __LINE__);
 	      ++nerr;
 	    }
 	  if ( this->real_address[SH_MEMMULT-1] != CHECKBYTE )
 	    {
-	      merr = calloc(1, sizeof(memlist_t));
-	      
-	      memcpy(merr, this, sizeof(memlist_t));
-	      merr->size = 0;
-	      
-	      merr->next = merrlist;
-	      merrlist   = merr;
+	      sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MUNDER,
+			       this->file, this->line, FIL__, __LINE__);
 	      ++nerr;
 	    }
@@ -235,25 +206,5 @@
     }
 
-
-  SH_MUTEX_RECURSIVE_UNLOCK(mutex_mem);
-
-  while (merrlist != NULL) 
-    {
-      memlist_t   * tmp = merrlist;
-      merrlist = merrlist->next;
-      
-      if (tmp->size == 2)
-	  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MNULL,
-			   tmp->file, tmp->line, FIL__, __LINE__);
-      if (tmp->size == 1)
-	  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MOVER,
-			   tmp->file, tmp->line, FIL__, __LINE__);
-      else
-	  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MUNDER,
-			   tmp->file, tmp->line, FIL__, __LINE__);
-      free(tmp);
-      SH_ABORT;
-      _exit (EXIT_FAILURE);
-    }
+  /* if (nerr > 0) abort(); */
 
   SL_RET0(_("sh_mem_check"));
@@ -268,16 +219,21 @@
   SL_ENTER(_("sh_mem_malloc"));
 
-  SH_MUTEX_RECURSIVE_INIT(mutex_mem);
-  SH_MUTEX_RECURSIVE_LOCK(mutex_mem);
-
-  the_realAddress = calloc(1,size + 2 * SH_MEMMULT);
+  the_realAddress = malloc(size + 2 * SH_MEMMULT);
   
   if ( the_realAddress  == NULL ) 
     {
-      (void) safe_logger (0, 0, NULL);
-
+      if (eblock == 0)
+	{
+	  eblock = 1;
+	  (void) safe_logger (0, 0, getpid());
+	  /*
+	  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MMEM,
+			   file, line);
+	  */
+	  eblock = 0;
+	}
       /* use _exit() rather than exit() - we malloc() in atexit() functions 
        */
-      _exit (EXIT_FAILURE);
+      _exit (42);
     }
   
@@ -296,68 +252,110 @@
     Max_Alloc_Count = Now_Alloc_Count;
 
+#ifdef MEM_DETAILS
+  if (size <= 32)
+    { 
+      ++now_upto_032;
+      ++tot_upto_032;
+      if (now_upto_032 > max_upto_032) max_upto_032 = now_upto_032;
+    }
+  else if  (size <= 64)
+    { 
+      ++now_upto_064;
+      ++tot_upto_064;
+      if (now_upto_064 > max_upto_064) max_upto_064 = now_upto_064;
+    }
+  else if  (size <= 128)
+    { 
+      ++now_upto_128;
+      ++tot_upto_128;
+      if (now_upto_128 > max_upto_128) max_upto_128 = now_upto_128;
+    }
+  else if  (size <= 256)
+    { 
+      ++now_upto_256;
+      ++tot_upto_256;
+      if (now_upto_256 > max_upto_256) max_upto_256 = now_upto_256;
+    }
+  else if  (size <= 512)
+    { 
+      ++now_upto_512;
+      ++tot_upto_512;
+      if (now_upto_512 > max_upto_512) max_upto_512 = now_upto_512;
+    }
+  else if  (size <= 1024)
+    { 
+      ++now_upto_1024;
+      ++tot_upto_1024;
+      if (now_upto_1024 > max_upto_1024) max_upto_1024 = now_upto_1024;
+    }
+  else if  (size <= 4096)
+    { 
+      ++now_upto_4096;
+      ++tot_upto_4096;
+      if (now_upto_4096 > max_upto_4096) max_upto_4096 = now_upto_4096;
+    }
+  else 
+    { 
+      ++now_upto_inf;
+      ++tot_upto_inf;
+      if (now_upto_inf > max_upto_inf) max_upto_inf = now_upto_inf;
+
+      fprintf(stderr, "\n___BIGSIZE___");
+      fprintf(stderr, "   %6d  -> %16s  %10d \n", size, file, line);
+      fprintf(stderr, "\n");
+
+    }
+#endif
+
   Mem_Current += size;
   Mem_Max = ( (Mem_Current > Mem_Max) ? Mem_Current : Mem_Max);
 
-  this = calloc(1,sizeof(memlist_t));
+  this = (memlist_t *) malloc (sizeof(memlist_t));
 
   if ( this == NULL) 
     {
-      (void) safe_logger(0, 0, NULL);
-
-      _exit(EXIT_FAILURE);
-    }
-  else
-    {
-      /* make list entry */
-
-      this->real_address = the_realAddress;
-      this->address      = theAddress;
-      this->size         = size;
-      this->line         = line;
-      sl_strlcpy(this->file, file, 20);
-
-      this->next = memlist;
-      memlist = this;
-    }
-
-  SH_MUTEX_RECURSIVE_UNLOCK(mutex_mem);
+      if (eblock == 0)
+	{
+	  eblock = 1;
+	  (void) safe_logger(0, 0, getpid());
+	  /*
+	  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MMEM,
+			   file, line);
+	  */
+	  eblock = 0;
+	}
+      SL_RETURN( the_realAddress, _("sh_mem_malloc"));
+    }
+
+  /* make list entry */
+
+  this->real_address = the_realAddress;
+  this->address      = theAddress;
+  this->size         = size;
+  this->line         = line;
+  sl_strlcpy(this->file, file, 20);
+
+  this->next = memlist;
+  memlist = this;
+
   SL_RETURN( theAddress, _("sh_mem_malloc"));
 }
 
-void ** sh_mem_dummy_a;
-memlist_t ** sh_mem_merr_3;
-
-void sh_mem_free (void * aa, char * file, int line)
-{
-  memlist_t * this;
-  memlist_t * before;
-  memlist_t * merr;
-  memlist_t * merrlist = NULL;
-  unsigned long        size   = 0;
-  void      * a;
-  volatile int         flag = 0;
+
+void sh_mem_free (void * a, char * file, int line)
+{
+  memlist_t * this   = memlist;
+  memlist_t * before = memlist;
+  unsigned long size = 0;
 
   SL_ENTER(_("sh_mem_free"));
 
-  a      = aa;
-  sh_mem_dummy_a = &a;
-  sh_mem_merr_3  = (memlist_t **) &merrlist;
-
-
   if ( a == NULL ) 
     {
       sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MNULL,
-		       file, line, FIL__, __LINE__);
-      SH_ABORT;
-      _exit (EXIT_FAILURE);
+		       file, line);
       SL_RET0(_("sh_mem_free"));
     }
     
-  SH_MUTEX_RECURSIVE_INIT(mutex_mem);
-  SH_MUTEX_RECURSIVE_LOCK(mutex_mem);
-
-  this   = memlist;
-  before = memlist;
-  
   /* -- Find record. -- 
    */
@@ -372,6 +370,7 @@
   if (this == NULL) 
     {
-      flag = 1;
-      goto out;
+      sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MREC,
+		       file, line);
+      SL_RET0(_("sh_mem_free"));
     } 
   else 
@@ -381,23 +380,10 @@
       if ( this->address[this->size]        != CHECKBYTE )
 	{
-	  merr = calloc(1, sizeof(memlist_t));
-
-	  memcpy(merr, this, sizeof(memlist_t));
-	  merr->size = 1;
-
-	  merr->next = merrlist;
-	  merrlist = merr;
-	}
-
+	  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MOVER,
+			   this->file, this->line, file, line);
+	}
       if ( this->real_address[SH_MEMMULT-1] != CHECKBYTE )
-	{
-	  merr = calloc(1,sizeof(memlist_t));
-
-	  memcpy(merr, this, sizeof(memlist_t));
-	  merr->size = 0;
-
-	  merr->next = merrlist;
-	  merrlist = merr;
-	}
+	sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MUNDER,
+			 this->file, this->line, file, line);
 
       size = this->size;
@@ -412,33 +398,27 @@
   if (this)
     free(this);
-
   ++Free_Count;
   --Now_Alloc_Count;
 
+#ifdef MEM_DETAILS
+  if (size <= 32)
+    --now_upto_032;
+  else if  (size <= 64)
+    --now_upto_064;
+  else if  (size <= 128)
+    --now_upto_128;
+  else if  (size <= 256)
+    --now_upto_256;
+  else if  (size <= 512)
+    --now_upto_512;
+  else if  (size <= 1024)
+    --now_upto_1024;
+  else if  (size <= 4096)
+    --now_upto_4096;
+  else 
+    --now_upto_inf;
+#endif
+
   Mem_Current -= size;
- out:
-  ; /* label at end of compound statement */
-  SH_MUTEX_RECURSIVE_UNLOCK(mutex_mem);
-
-  while (merrlist != NULL) 
-    {
-      memlist_t   * tmp = merrlist;
-      merrlist = merrlist->next;
-      
-      if (tmp->size == 1)
-	  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MOVER,
-			   tmp->file, tmp->line, file, line);
-      else
-	  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MUNDER,
-			   tmp->file, tmp->line, file, line);
-      free(tmp);
-      SH_ABORT;
-      _exit (EXIT_FAILURE);
-    }
-
-  if (flag != 0)
-    sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MREC,
-		     file, line);
-
   SL_RET0(_("sh_mem_free"));
 }
@@ -457,5 +437,4 @@
     {
       sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MNULL);
-      SH_ABORT;
     }
   SL_RET0(_("sh_mem_free"));
@@ -468,19 +447,24 @@
   SL_ENTER(_("sh_mem_malloc"));
 
-  theAddress = calloc(1,size);
-
-  if ( theAddress != NULL ) 
-    {
-      SL_RETURN( theAddress, _("sh_mem_malloc"));
-    }
-  else
-    {
-      (void) safe_logger(0, 0, NULL);
-
+  theAddress = malloc(size);
+
+  if ( theAddress == NULL ) 
+    {
+      if (eblock == 0)
+	{
+	  eblock = 1;
+	  (void) safe_logger(0, 0, getpid());
+	  /*
+	  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_MMEM);
+	  */
+	  eblock = 0;
+	}
       /* use _exit() rather than exit() - we malloc() in atexit()  
        */
-      SH_ABORT;
-      _exit (EXIT_FAILURE);
-    }
-}
-#endif
+      _exit (42);
+    }
+  /* memset (theAddress, 0, 1); *//* needs testing */
+
+  SL_RETURN( theAddress, _("sh_mem_malloc"));
+}
+#endif
Index: /trunk/src/sh_modules.c
===================================================================
--- /trunk/src/sh_modules.c	(revision 584)
+++ /trunk/src/sh_modules.c	(revision 1)
@@ -7,15 +7,10 @@
 
 #include "sh_modules.h"
-#include "sh_pthread.h"
 
 #include "sh_utmp.h"
 #include "sh_mounts.h"
 #include "sh_userfiles.h"
+#include "sh_kern.h"
 #include "sh_suidchk.h"
-#include "sh_processcheck.h"
-#include "sh_portcheck.h"
-#include "sh_logmon.h"
-#include "sh_registry.h"
-#include "sh_fInotify.h"
 
 sh_mtype modList[] = {
@@ -23,15 +18,13 @@
   {
     N_("UTMP"),
-    -1,
-    SH_MODFL_NOTIMER,
+    0,
     sh_utmp_init,
     sh_utmp_timer,
     sh_utmp_check,
     sh_utmp_end,
-    sh_utmp_reconf,
+    sh_utmp_null,
 
     N_("[Utmp]"),
     sh_utmp_table,
-    PTHREAD_MUTEX_INITIALIZER,
   },
 #endif
@@ -40,5 +33,4 @@
   {
     N_("MOUNTS"),
-    -1,
     0,
     sh_mounts_init,
@@ -50,5 +42,4 @@
     N_("[Mounts]"),
     sh_mounts_table,
-    PTHREAD_MUTEX_INITIALIZER,
   },
 #endif
@@ -57,5 +48,4 @@
   {
     N_("USERFILES"),
-    -1,
     0,
     sh_userfiles_init,
@@ -67,12 +57,24 @@
     N_("[UserFiles]"),
     sh_userfiles_table,
-    PTHREAD_MUTEX_INITIALIZER,
   },
 #endif
 
+#ifdef SH_USE_KERN
+  {
+    N_("KERNEL"),
+    0,
+    sh_kern_init,
+    sh_kern_timer,
+    sh_kern_check,
+    sh_kern_end,
+    sh_kern_null,
+
+    N_("[Kernel]"),
+    sh_kern_table,
+  },
+#endif
 #ifdef SH_USE_SUIDCHK
   {
     N_("SUIDCHECK"),
-    -1,
     0,
     sh_suidchk_init,
@@ -80,100 +82,12 @@
     sh_suidchk_check,
     sh_suidchk_end,
-    sh_suidchk_reconf,
+    sh_suidchk_free_schedule,
 
     N_("[SuidCheck]"),
     sh_suidchk_table,
-    PTHREAD_MUTEX_INITIALIZER,
   },
 #endif
-
-#ifdef SH_USE_PROCESSCHECK
-  {
-    N_("PROCESSCHECK"),
-    -1,
-    0,
-    sh_prochk_init,
-    sh_prochk_timer,
-    sh_prochk_check,
-    sh_prochk_cleanup,
-    sh_prochk_reconf,
-
-    N_("[ProcessCheck]"),
-    sh_prochk_table,
-    PTHREAD_MUTEX_INITIALIZER,
-  },
-#endif
-
-#ifdef SH_USE_PORTCHECK
-  {
-    N_("PORTCHECK"),
-    -1,
-    0,
-    sh_portchk_init,
-    sh_portchk_timer,
-    sh_portchk_check,
-    sh_portchk_cleanup,
-    sh_portchk_reconf,
-
-    N_("[PortCheck]"),
-    sh_portchk_table,
-    PTHREAD_MUTEX_INITIALIZER,
-  },
-#endif
-
-#ifdef USE_LOGFILE_MONITOR
-  {
-    N_("LOGMON"),
-    -1,
-    0,
-    sh_log_check_init,
-    sh_log_check_timer,
-    sh_log_check_check,
-    sh_log_check_cleanup,
-    sh_log_check_reconf,
-
-    N_("[Logmon]"),
-    sh_log_check_table,
-    PTHREAD_MUTEX_INITIALIZER,
-  },
-#endif
-
-#ifdef USE_REGISTRY_CHECK
-  {
-    N_("REGISTRY"),
-    -1,
-    0,
-    sh_reg_check_init,
-    sh_reg_check_timer,
-    sh_reg_check_run,
-    sh_reg_check_cleanup,
-    sh_reg_check_reconf,
-
-    N_("[Registry]"),
-    sh_reg_check_table,
-    PTHREAD_MUTEX_INITIALIZER,
-  },
-#endif
-
-#if defined(HAVE_SYS_INOTIFY_H)
-  {
-    N_("INOTIFY"),
-    -1,
-    SH_MODFL_NEEDPAUSED,
-    sh_fInotify_init,
-    sh_fInotify_timer,
-    sh_fInotify_run,
-    sh_fInotify_cleanup,
-    sh_fInotify_reconf,
-
-    N_("[Inotify]"),
-    sh_fInotify_table,
-    PTHREAD_MUTEX_INITIALIZER,
-  },
-#endif
-
   {
     NULL,
-    -1,
     0,
 
@@ -186,5 +100,4 @@
     NULL,
     NULL,
-    PTHREAD_MUTEX_INITIALIZER,
   },
 };
Index: /trunk/src/sh_mounts.c
===================================================================
--- /trunk/src/sh_mounts.c	(revision 584)
+++ /trunk/src/sh_mounts.c	(revision 1)
@@ -51,9 +51,9 @@
 
 /* Prototypes for configuration functions */
-int sh_mounts_config_activate (const char * opt);
-int sh_mounts_config_timer    (const char * opt);
-int sh_mounts_config_mount    (const char * opt);
-int sh_mounts_config_sevmnt   (const char * opt);
-int sh_mounts_config_sevopt   (const char * opt);
+int sh_mounts_config_activate (char * opt);
+int sh_mounts_config_timer    (char * opt);
+int sh_mounts_config_mount    (char * opt);
+int sh_mounts_config_sevmnt   (char * opt);
+int sh_mounts_config_sevopt   (char * opt);
 
 /* Prototype for the function to read info on mounted filesystems */
@@ -157,6 +157,6 @@
 static int    ShMountsActive    = S_FALSE;
 static time_t ShMountsInterval  = 86400;
-static int    ShMountsSevMnt    = SH_ERR_ERR;
-static int    ShMountsSevOpt    = SH_ERR_ERR;
+static int    ShMountsSevMnt    = 7;
+static int    ShMountsSevOpt    = 7;
 
 static struct sh_mounts_mnt *mountlist = NULL;
@@ -165,7 +165,6 @@
  * This is called once at the start of each samhain run.
  * Non-configuration setup code should be placed here. */
-int sh_mounts_init (struct mod_type * arg)
-{
-  (void) arg;
+int sh_mounts_init ()
+{
   SL_ENTER(_("sh_mounts_init"));
 
@@ -180,4 +179,6 @@
   }
 
+  lastcheck = time(NULL);
+
   SL_RETURN(0, _("sh_mounts_init"));
 }
@@ -195,5 +196,5 @@
     SL_RETURN(-1, _("sh_mounts_timer"));
   }
- 
+  
   SL_RETURN(0, _("sh_mounts_timer"));
 }
@@ -261,6 +262,6 @@
 
 /* Module reconfiguration
- * Run on receipt of a HUP.
- */
+ * Run on receipt of a HUP. Right now this is identical to _end(), but it may
+ * not always be. */
 int sh_mounts_reconf()
 {
@@ -268,12 +269,4 @@
   sh_mounts_mnt_free(mountlist);
   mountlist = NULL;
-
-  /* re-set defaults
-   */
-  ShMountsActive    = S_FALSE;
-  ShMountsInterval  = 86400;
-  ShMountsSevMnt    = 7;
-  ShMountsSevOpt    = 7;
-
   SL_RETURN( (0), _("sh_mounts_null"));
 }
@@ -283,9 +276,9 @@
 
 /* Configure to check a particular mount */
-int sh_mounts_config_mount (const char * opt_in)
+int sh_mounts_config_mount (char * opt)
 {
   struct sh_mounts_mnt *m;
   struct sh_mounts_opt *o;
-  char *sp, *temp, *opt;
+  char *sp, *temp;
 
   SL_ENTER(_("sh_mounts_config_mount"));
@@ -293,9 +286,9 @@
   /* It's probably best to make a copy of opt before messing about with it
    * via string functions. Good practice and all that. */
-  temp = sh_util_strdup(opt_in);
+  temp = sh_util_strdup(opt);
 
   /* Since we're going to "consume" this new buffer, it'll be good to have a
    * reference to it's allocated memory so we can free it later. Let's use
-   * temp for that, and "opt" for consumption */
+   * temp for that, and the now-unused "opt" for consumption */
   opt = temp;
   
@@ -334,5 +327,5 @@
 
 /* Simply sets our boolean as to whether this module is active */
-int sh_mounts_config_activate (const char * opt)
+int sh_mounts_config_activate (char * opt)
 {
   int i;
@@ -343,5 +336,5 @@
 
 /* Sets up our timer */
-int sh_mounts_config_timer (const char * opt)
+int sh_mounts_config_timer (char * opt)
 {
   long val;
@@ -364,5 +357,5 @@
 
 /* Configure severity for "mount missing" messages */
-int sh_mounts_config_sevmnt  (const char * opt)
+int sh_mounts_config_sevmnt  (char * opt)
 {
   int retval = 0;
@@ -377,5 +370,5 @@
 }
 
-int sh_mounts_config_sevopt  (const char * opt)
+int sh_mounts_config_sevopt  (char * opt)
 {
   int retval = 0;
@@ -398,5 +391,5 @@
 
 /* FreeBSD includes */
-#if defined(HOST_IS_FREEBSD) || defined(HOST_IS_OPENBSD) || defined(HOST_IS_DARWIN)
+#ifdef HOST_IS_FREEBSD
 #include <sys/param.h>
 #include <sys/ucred.h>
@@ -457,5 +450,6 @@
   
   while ((c = getc (fd)) == '*') {
-    while (((c = getc (fd)) != '\n') && (c != EOF)) {} /* do nothing */
+    while (((c = getc (fd)) != '\n') && (c != EOF)) {
+    }
   }
 }
@@ -572,8 +566,8 @@
 
 /* end AIX helper routines */
-#endif 
-#endif
-
-#if defined(HOST_IS_FREEBSD) || defined(HOST_IS_OPENBSD) || defined(HOST_IS_DARWIN)
+#endif
+#endif
+
+#if defined(HOST_IS_FREEBSD)
 
 /* FreeBSD returns flags instead of strings as mount options, so we'll convert
@@ -585,31 +579,12 @@
 
 	struct {char *opt; int flag;} table[] = {
-#ifdef MNT_RDONLY
 		{"ro",		MNT_RDONLY},
-#endif
-#ifdef MNT_NOEXEC
 		{"noexec",	MNT_NOEXEC},
-#endif
-#ifdef MNT_NOSUID
 		{"nosuid",	MNT_NOSUID},
-#endif
-#ifdef MNT_NODEV
 		{"nodev",	MNT_NODEV},
-#endif
-#ifdef MNT_SYNCHRONOUS
 		{"sync",	MNT_SYNCHRONOUS},
-#endif
-#ifdef MNT_ASYNC
 		{"async",	MNT_ASYNC},
-#endif
-#ifdef MNT_LOCAL
 		{"local",	MNT_LOCAL},
-#endif
-#ifdef MNT_QUOTA
 		{"quota",	MNT_QUOTA},
-#endif
-#ifdef MNT_NOATIME
-		{"noatime",	MNT_NOATIME},
-#endif
 		{"bound",	-1}
 	};
@@ -682,6 +657,6 @@
 	list = m;
 
-/* The Open/FreeBSD way */
-#if defined(HOST_IS_FREEBSD) || defined(HOST_IS_OPENBSD) || defined(HOST_IS_DARWIN)
+/* The FreeBSD way */
+#ifdef HOST_IS_FREEBSD
 {
 	struct statfs *fsp;
@@ -749,5 +724,5 @@
 	}
 
-	sl_fclose(FIL__, __LINE__, tab);
+	fclose(tab);
 }
 #endif
@@ -806,5 +781,5 @@
         }
 
-        (void) sl_fclose(FIL__, __LINE__, tab);
+        (void) fclose(tab);
 	aix_fs_get (NULL, NULL); /* reset */
 }
Index: /trunk/src/sh_prelink.c
===================================================================
--- /trunk/src/sh_prelink.c	(revision 584)
+++ /trunk/src/sh_prelink.c	(revision 1)
@@ -38,6 +38,7 @@
 static char * prelink_hash = NULL;
 
-int sh_prelink_set_path (const char * str)
-{
+int sh_prelink_set_path (char * str)
+{
+  size_t len;
   SL_ENTER(_("sh_prelink_set_path"));
   if (prelink_path != NULL)
@@ -48,14 +49,11 @@
       SL_RETURN((-1), _("sh_prelink_set_path")); 
     }
-#ifdef SH_EVAL_SHELL
-  prelink_path = sh_util_strdup(str);
+  len = sl_strlen (str);
+  prelink_path = SH_ALLOC(len+1);
+  (void) sl_strlcpy(prelink_path, str, len+1);
   SL_RETURN(0, _("sh_prelink_set_path")); 
-#else
-  prelink_path = NULL;
-  SL_RETURN((-1), _("sh_prelink_set_path"));
-#endif
-}
-
-int sh_prelink_set_hash (const char * str)
+}
+
+int sh_prelink_set_hash (char * str)
 {
   size_t len;
@@ -74,37 +72,23 @@
 }
 
-int sh_prelink_iself (SL_TICKET fd, off_t size, int alert_timeout, char * path)
-{
-  long   status;
-  char   magic[4];
-  char * tmp;
-
-  /* 42 bytes is about the minimum an ELF binary might have
-   * (with plenty of hacks to reduce the size, such as interleaving
-   * the code with the header...)
-   */
-  if (size < 42)
-    return S_FALSE;
-
-  status = sl_read_timeout (fd, magic, 4, alert_timeout, S_FALSE);
-  (void) sl_rewind(fd);
-  if (status == 4)
-    {
-      /*@-usedef@*/
-      if (magic[0] == (char) 0x7f &&
-	  magic[1] == 'E'  &&
-	  magic[2] == 'L'  &&
-	  magic[3] == 'F')
-	return S_TRUE;
-      /*@+usedef@*/
-    }
-  else
-    {
-      tmp = sh_util_safe_name (path);
-      sh_error_handle(SH_ERR_ERR, FIL__, __LINE__, status, MSG_E_SUBGPATH, 
-		      _("Error reading file"), _("sh_prelink_iself"), tmp);
-      SH_FREE(path);
-    }
-  return S_FALSE;
+int sh_prelink_iself (SL_TICKET fd, off_t size, int alert_timeout)
+{
+   long status;
+   char magic[4];
+   if (size < 42)
+	return S_FALSE;
+   status = sl_read_timeout (fd, magic, 4, alert_timeout);
+   (void) sl_rewind(fd);
+   if (status == 4)
+     {
+       /*@-usedef@*/
+       if (magic[0] == (char) 0x7f &&
+	   magic[1] == 'E'  &&
+	   magic[2] == 'L'  &&
+	   magic[3] == 'F')
+	 return S_TRUE;
+       /*@+usedef@*/
+     }
+   return S_FALSE;
 }
 
@@ -115,5 +99,4 @@
   SL_TICKET ticket;
   char * tmp;
-  char hashbuf[KEYBUF_SIZE];
 
   if (task->com_ti != (-1))
@@ -123,21 +106,17 @@
       task->com_ti = -1;
     }
-  ticket = sl_open_read(FIL__, __LINE__, task->command, 
+  ticket = sl_open_read(task->command, 
 			task->privileged == 0 ? SL_NOPRIV : SL_YESPRIV);
   if (SL_ISERROR(ticket))
     {
-      char errbuf[SH_ERRBUF_SIZE];
-      char errbuf2[SH_ERRBUF_SIZE];
-      sh_error_message(errno, errbuf2, sizeof(errbuf2));
-      sl_strlcpy(errbuf, sl_error_string(ticket), sizeof(errbuf));
       tmp = sh_util_safe_name (task->command);
-      sh_error_handle(SH_ERR_ERR, FIL__, __LINE__, ticket, MSG_E_READ, errbuf, errbuf2, tmp);
+      sh_error_handle(SH_ERR_ERR, FIL__, __LINE__, ticket, MSG_E_READ, tmp);
       SH_FREE(tmp);
       return;
     }
-
+  tiger_fd = ticket;
   if (*(task->checksum) == '\0' ||
       0 == sl_strcmp(task->checksum, 
-		     sh_tiger_hash (task->command, ticket, TIGER_NOLIM, hashbuf, sizeof(hashbuf))))
+		     sh_tiger_hash (task->command, TIGER_FD, 0)))
     {
       task->com_fd = get_the_fd(ticket);
@@ -156,5 +135,5 @@
 /* returns static storage
  */
-int sh_prelink_run (char * path, char * file_hash, int alert_timeout, unsigned long mask)
+int sh_prelink_run (char * path, char * file_hash, int alert_timeout)
 {
   static int      init = S_FALSE;
@@ -164,4 +143,6 @@
   int    status = 0;
   char * p;
+  struct  sigaction  new_act;
+  struct  sigaction  old_act;
 
   SL_ENTER(_("sh_prelink_run"));
@@ -185,8 +166,6 @@
   if (init == S_FALSE)
     {
-      char dir[SH_PATHBUF];
-
       sh_ext_tas_init(&task);
-      p = sh_unix_getUIDdir (SH_ERR_ERR, task.run_user_uid, dir, sizeof(dir));
+      p = sh_unix_getUIDdir (SH_ERR_ERR, task.run_user_uid);
       if (p)
 	{
@@ -255,17 +234,18 @@
     }
 
+  /* ignore SIGPIPE (instead get EPIPE if connection is closed)
+   */
+  new_act.sa_handler = SIG_IGN;
+  (void) retry_sigaction (FIL__, __LINE__, SIGPIPE, &new_act, &old_act);
+
   /* read from pipe
    */
-  sl_read_timeout_prep (task.pipeTI);
-
-  {
-    char hashbuf[KEYBUF_SIZE];
-    UINT64 length_nolim = TIGER_NOLIM;
-    if (sh.flag.opts == S_TRUE) sh_tiger_set_hashtype_mask(mask);
-    sl_strlcpy(file_hash,
-	       sh_tiger_generic_hash (path, task.pipeTI, &length_nolim, alert_timeout,
-				      hashbuf, sizeof(hashbuf)),
-	       KEY_LEN+1);
-  }
+  tiger_fd = task.pipeTI;
+  strcpy(file_hash,                        /* known to fit */
+	 sh_tiger_generic_hash (path, TIGER_FD, 0, alert_timeout));
+
+  /* restore old signal handler
+   */
+  (void) retry_sigaction (FIL__, __LINE__, SIGPIPE, &old_act, NULL);
 
   /* close pipe and return exit status
